//********************************************************************** 
/*
@@w@\J^E^C}x 
*/
//********************************************************************** 
//}N`
#define BYTE            unsigned  short
#define WORD            unsigned  int
#define DWORD           unsigned  long
//
#define CR              0x0D
#define LF              0x0A
//
#define INPUT_MODE      1
#define OUTPUT_MODE     0
//
#define SW_MODE_1       SW4
#define SW_MODE_0       SW3
//
#define SW_START        SW1
#define SW_STOP         SW2
//
#define SW_HOUR         SW1
#define SW_MINUTE       SW2
//
#define SW_MONTH        SW1
#define SW_DAY          SW2
//
#define SW_UP           SW1
#define SW_DOWN         SW2
//
#define SW_PORT         &PORTE
//
sbit    SW1                 at    RE2_bit;
sbit    SW2                 at    RE1_bit;
sbit    SW3                 at    RE0_bit;
sbit    SW4                 at    RE3_bit;
sbit    SW1_Direction       at    TRISE2_bit;
sbit    SW2_Direction       at    TRISE1_bit;
sbit    SW3_Direction       at    TRISE0_bit;
//sbit    SW4_Direction       at    TRISE3_bit;
sbit    LED1                at    RD4_bit;
sbit    LED2                at    RD5_bit;
sbit    LED3                at    RD6_bit;
sbit    LED4                at    RD7_bit;
sbit    LED1_Direction      at    TRISD4_bit;
sbit    LED2_Direction      at    TRISD5_bit;
sbit    LED3_Direction      at    TRISD6_bit;
sbit    LED4_Direction      at    TRISD7_bit;
#define CH_PORT             PORTB
sbit    CH1                 at    RB0_bit;
sbit    CH2                 at    RB1_bit;
sbit    CH3                 at    RB2_bit;
sbit    CH4                 at    RB3_bit;
sbit    CH5                 at    RB4_bit;
sbit    CH6                 at    RB5_bit;
sbit    CH7                 at    RB6_bit;
sbit    CH8                 at    RB7_bit;
sbit    CH1_Direction       at    TRISB0_bit;
sbit    CH2_Direction       at    TRISB1_bit;
sbit    CH3_Direction       at    TRISB2_bit;
sbit    CH4_Direction       at    TRISB3_bit;
sbit    CH5_Direction       at    TRISB4_bit;
sbit    CH6_Direction       at    TRISB5_bit;
sbit    CH7_Direction       at    TRISB6_bit;
sbit    CH8_Direction       at    TRISB7_bit;
//********************************************************************** 
//֐錾
extern  void    main();
extern  void    init_lcd();
extern  void    init_sdc();
extern  BYTE    RTC_8564_Read(BYTE addr);
extern  void    RTC_8564_Write(BYTE addr, BYTE dat);
extern  void    get_date_time(char * dat);
extern  void    disp_date_time();
extern  void    init_rtc();
extern  void    init_port();
extern  void    init_usart();
extern  void    init_adc();
extern  void    init_comparator();
extern  void    all_complete();
extern  void    file_open(char *fname);
extern  short   file_read_line(BYTE *line_data);
extern  void    timer_proc_def(char *line_data, BYTE *on_data, BYTE *off_data);
extern  void    timer_proc_init(char *line_data, BYTE on_data, BYTE off_data);
extern  void    timer_proc_start(char *line_data, BYTE on_data, BYTE off_data);
extern  void    timer_proc();
extern  short   get_mode();
extern  void    run_mode0();
extern  void    run_mode1();
extern  void    run_mode2();
extern  void    run_mode3();
extern  void    write_file_name();
extern  void    read_file_name();
extern  void    chrrep(char *str, char a, char b);
//********************************************************************** 
//Lϐ
char    *file_name = "timer001.txt";
int     file_id = 1;
char    buf[32];
//********************************************************************** 
//C֐łB 
void    main()
{
        //e탂W[̏s܂B 
        init_adc();
        init_comparator();
        init_port();
        init_lcd();
        init_sdc();
        init_rtc();
        init_usart();
        read_file_name();
        //
        all_complete();
        //
        while (1) {
                //b̕\ 
                disp_date_time();
                //
                switch (get_mode()) {
                case 0:
                        LED1 = 1;
                        LED2 = 0;
                        LED3 = 0;
                        LED4 = 0;
                        run_mode0();
                        break;
                case 1:
                        LED1 = 0;
                        LED2 = 1;
                        LED3 = 0;
                        LED4 = 0;
                        run_mode1();
                        break;
                case 2:
                        LED1 = 0;
                        LED2 = 0;
                        LED3 = 1;
                        LED4 = 0;
                        run_mode2();
                        break;
                case 3:
                        LED1 = 0;
                        LED2 = 0;
                        LED3 = 0;
                        LED4 = 1;
                        run_mode3();
                        break;
                }
        }
}
//********************************************************************** 
//kbc̏֐łB 
sbit    LCD_RS              at    RA5_bit;
sbit    LCD_EN              at    RA4_bit;
sbit    LCD_D7              at    RA0_bit;
sbit    LCD_D6              at    RA1_bit;
sbit    LCD_D5              at    RA2_bit;
sbit    LCD_D4              at    RA3_bit;
sbit    LCD_RS_Direction    at    TRISA5_bit;
sbit    LCD_EN_Direction    at    TRISA4_bit;
sbit    LCD_D7_Direction    at    TRISA0_bit;
sbit    LCD_D6_Direction    at    TRISA1_bit;
sbit    LCD_D5_Direction    at    TRISA2_bit;
sbit    LCD_D4_Direction    at    TRISA3_bit;
//
void    init_lcd()
{
        short   cnt;
        //
        Lcd_Init();
        Lcd_Cmd(_LCD_CLEAR);
        Lcd_Cmd(_LCD_CURSOR_OFF);
        Lcd_Out(1, 1, "Super Timer v1.0");
        Delay_ms(1000);
        for (cnt = 0; cnt < 16; cnt++) {
                Lcd_Chr(1, cnt + 1, 0xFF);
                Delay_ms(100);
        }
        for (cnt = 0; cnt < 16; cnt++) {
                Lcd_Chr(2, cnt + 1, 0xFF);
                Delay_ms(100);
        }
        Lcd_Cmd(_LCD_CLEAR);
}
//********************************************************************** 
//rcb̏֐łB 
sfr     sbit    Mmc_Chip_Select             at   RC2_bit;
sfr     sbit    Mmc_Chip_Select_Direction   at   TRISC2_bit;
//
void    init_sdc()
{
        SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV64, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_LOW_2_HIGH);
        if (Mmc_Fat_Init() != 0) {
                while (1) {
                        Lcd_Out(2, 1, "SDC error!");
                        Delay_ms(500);
                        Lcd_Out(2, 1, "          ");
                        Delay_ms(500);
                }
        }
        SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV16, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_LOW_2_HIGH);
        Lcd_Out(2, 1, "SDC complete!");
        Delay_ms(500);
        Lcd_Cmd(_LCD_CLEAR);
}
//********************************************************************** 
#define ACK     1
#define NO_ACK  0
//qsb̃f[^擾֐łB 
BYTE    RTC_8564_Read(BYTE addr)
{
        BYTE   dat;
        //
        Soft_I2C_Start();
        Soft_I2C_Write(0xA2);
        Soft_I2C_Write(addr);
        Soft_I2C_Start();
        Soft_I2C_Write(0xA3);
        dat = Soft_I2C_Read(NO_ACK);
        Soft_I2C_Stop();
        //
        return (dat);
}
//********************************************************************** 
//qsbւ̃f[^݊֐łB 
void    RTC_8564_Write(BYTE addr, BYTE dat)
{
        Soft_I2C_Start();
        Soft_I2C_Write(0xA2);
        Soft_I2C_Write(addr);
        Soft_I2C_Write(dat);
        Soft_I2C_Stop();
}
//********************************************************************** 
//qsbtibj擾֐łB 
void    get_date_time(char * dat)
{
        BYTE    td_month, td_day, td_hour, td_min, td_sec;
        //tibĵqsb̎擾 
        td_month = RTC_8564_Read(7) & 0x1F;
        td_day = RTC_8564_Read(5) & 0x3F;
        td_hour = RTC_8564_Read(4) & 0x3F;
        td_min = RTC_8564_Read(3) & 0x7F;
        td_sec = RTC_8564_Read(2) & 0x7F;
        //tibĵrcbւ̏ 
        dat[0] = (td_month >> 4) + '0';
        dat[1] = (td_month & 0x0F) + '0';
        dat[2] = '/';
        dat[3] = (td_day >> 4) + '0';
        dat[4] = (td_day & 0x0F) + '0';
        dat[5] = ' ';
        dat[6] = (td_hour >> 4) + '0';
        dat[7] = (td_hour & 0x0F) + '0';
        dat[8] = ':';
        dat[9] = (td_min >> 4) + '0';
        dat[10] = (td_min & 0x0F) + '0';
        dat[11] = ':';
        dat[12] = (td_sec >> 4) + '0';
        dat[13] = (td_sec & 0x0F) + '0';
        dat[14] = ' ';
        dat[15] = 0x00;
}
//********************************************************************** 
//b\֐łB 
void    disp_date_time()
{
        get_date_time(buf);
        Lcd_Out(1, 1, buf);
}
//********************************************************************** 
//qsb֐łB 
sbit  Soft_I2C_Scl            at  RD0_bit;
sbit  Soft_I2C_Sda            at  RD1_bit;
sbit  Soft_I2C_Scl_Direction  at  TRISD0_bit;
sbit  Soft_I2C_Sda_Direction  at  TRISD1_bit;
//
void    init_rtc()
{
        BYTE    td;
        //
        Soft_I2C_Init();
        //݂ƓǂݏõeXg܂B
        td = Dec2Bcd(10);  //2010 
        RTC_8564_Write(8, td);   //N̏
        td = RTC_8564_Read(8);   //N̓ǂݏo 
        if (Bcd2Dec(td) != 10) {
                while (1) {
                        Lcd_Out(2, 1, "RTC error!");
                        Delay_ms(500);
                        Lcd_Out(2, 1, "          ");
                        Delay_ms(500);
                }
        }        
        //
        Lcd_Out(2, 1, "RTC complete!");
        Delay_ms(500);
        Lcd_Cmd(_LCD_CLEAR);
}
//********************************************************************** 
//h^n|[g̏֐łB 
void    init_port()
{
        SW1_Direction  = INPUT_MODE;
        SW2_Direction  = INPUT_MODE;
        SW3_Direction  = INPUT_MODE;
//        SW4_Direction  = INPUT_MODE;
        LED1_Direction = OUTPUT_MODE;
        LED2_Direction = OUTPUT_MODE;
        LED3_Direction = OUTPUT_MODE;
        LED4_Direction = OUTPUT_MODE;
        LED1 = 0;
        LED2 = 0;
        LED3 = 0;
        LED4 = 0;
        CH1_Direction  = OUTPUT_MODE;
        CH2_Direction  = OUTPUT_MODE;
        CH3_Direction  = OUTPUT_MODE;
        CH4_Direction  = OUTPUT_MODE;
        CH5_Direction  = OUTPUT_MODE;
        CH6_Direction  = OUTPUT_MODE;
        CH7_Direction  = OUTPUT_MODE;
        CH8_Direction  = OUTPUT_MODE;
        CH1 = 0;
        CH2 = 0;
        CH3 = 0;
        CH4 = 0;
        CH5 = 0;
        CH6 = 0;
        CH7 = 0;
        CH8 = 0;
}
//********************************************************************** 
//qrQRQbitr`qsj̏֐łB 
sbit    USART_TX_Direction  at    TRISC6_bit;
sbit    USART_RX_Direction  at    TRISC7_bit;
//
void    init_usart()
{
        USART_TX_Direction  = 0;
        USART_RX_Direction  = 1;
        //
        UART1_Init(9600);
}
//********************************************************************** 
//`^cϊ̏֐łB 
void    init_adc()
{
        ADCON1.PCFG3 = 1;
        ADCON1.PCFG2 = 1;
        ADCON1.PCFG1 = 1;
        ADCON1.PCFG0 = 1;
}
//********************************************************************** 
//Rp[^̏֐łB 
void    init_comparator()
{
        CMCON.CM2 = 1;
        CMCON.CM1 = 1;
        CMCON.CM0 = 1;
}
//********************************************************************** 
//t@Cǂݍ݃[hŃI[v֐łB
DWORD   file_size, file_point;
//
short   file_open(char *fname)
{
        BYTE    sts;
        //
        sts = Mmc_Fat_Assign(fname, 0);
        if (sts == 0) {
                return (-1);
        }
        Mmc_Fat_Reset(&file_size);
        file_point = 0;
        return (0);
}
//********************************************************************** 
//t@CPs̃f[^ǂݍފ֐łB
short   file_read_line(BYTE *line_data)
{
        BYTE    character, cnt;
        //
        for (cnt = 0; cnt < 80; cnt++) {
                if (file_size == file_point) {
                        return (-1);
                }
                //
                Mmc_Fat_Read(&character);
                file_point++;
                if (character == ' ') {
                        cnt--;
                        continue;
                }
                if (character == CR) {
                        cnt--;
                        continue;
                }
                if (character == LF) {
                        line_data[cnt] = 0x00;
                        break;
                }
                line_data[cnt] = character;
        }
        return (cnt);
}
//********************************************************************** 
//^C}[i`ubNjs֐łB 
void    timer_proc_def(char *line_data, BYTE *on_data, BYTE *off_data, BYTE *hhmmss)
{
        char    *pnt;
        //
        pnt = strstr(line_data, "ON=");
        if (pnt != 0x00) {
                *on_data = *(pnt + 3) - '0';
        }
        pnt = strstr(line_data, "OFF=");
        if (pnt != 0x00) {
                *off_data = *(pnt + 4) - '0';
        }
        //
        pnt = strstr(line_data, "MODE=");
        if (pnt != 0x00) {
                *hhmmss = *(pnt + 5) - '0';
        }       
}
//********************************************************************** 
//^C}[iubNjs֐łB 
void    timer_proc_init(char *line_data, BYTE on_data, BYTE off_data)
{
        char    tmp[8], *pnt;
        BYTE    channel, output_data;
        //
        if (strstr(line_data, "ALL_ON") != 0x00) {
                CH1 = on_data;
                CH2 = on_data;
                CH3 = on_data;
                CH4 = on_data;
                CH5 = on_data;
                CH6 = on_data;
                CH7 = on_data;
                CH8 = on_data;
        }
        if (strstr(line_data, "ALL_OFF") != 0x00) {
                CH1 = off_data;
                CH2 = off_data;
                CH3 = off_data;
                CH4 = off_data;
                CH5 = off_data;
                CH6 = off_data;
                CH7 = off_data;
                CH8 = off_data;
        }
        if (strstr(line_data, "ALL_REV") != 0x00) {
                CH_PORT = ~CH_PORT;
        }
        tmp[0] = 'C';
        tmp[1] = 'H';
        tmp[2] = '?';
        tmp[3] = '=';
        tmp[4] = 0x00;
        for (channel = 1; channel <= 8; channel++) {
                tmp[2] = channel + '0';
                pnt = strstr(line_data, tmp);
                if (pnt != 0x00) {
                        if (strncmp((pnt + 4), "ON", 2) == 0) {
                                output_data = on_data;
                        } else {
                                output_data = off_data;
                        }
                        switch (channel) {
                        case 1:
                                CH1 = output_data;
                                break;
                        case 2:
                                CH2 = output_data;
                                break;
                        case 3:
                                CH3 = output_data;
                                break;
                        case 4:
                                CH4 = output_data;
                                break;
                        case 5:
                                CH5 = output_data;
                                break;
                        case 6:
                                CH6 = output_data;
                                break;
                        case 7:
                                CH7 = output_data;
                                break;
                        case 8:
                                CH8 = output_data;
                                break;
                        }
                }
        }
}
//********************************************************************** 
//^C}[iJnubNjs֐łB 
void    timer_proc_start(char *line_data, BYTE on_data, BYTE off_data, BYTE hhmmss)
{
        char    tmp[8], *pnt;
        BYTE    channel, output_data;
        BYTE    hh, mm, ss, hhTmp, mmTmp, ssTmp;
        //䎞Ԃ擾B 
        if (line_data[2] == ':') {
                line_data[2] = 0x00;
                hh = atoi(line_data);
                line_data[2] = ':';
        } else {
                return;
        }
        if (line_data[5] == ':') {
                line_data[5] = 0x00;
                mm = atoi(&line_data[3]);
                line_data[5] = ':';
        } else {
                return;
        }
        if (line_data[8] == ',') {
                line_data[8] = 0x00;
                ss = atoi(&line_data[6]);
                line_data[8] = ',';
        } else {
                return;
        }
        //䎞ԂmFB 
        while (1) {
                hhTmp = Bcd2Dec(RTC_8564_Read(4) & 0x3F);
                mmTmp = Bcd2Dec(RTC_8564_Read(3) & 0x7F);
                ssTmp = Bcd2Dec(RTC_8564_Read(2) & 0x7F);
                if ((hhmmss == 0) && (hh == hhTmp) && (mm == mmTmp) && (ss == ssTmp)) {
                        break;
                }
                if ((hhmmss == 1) && (mm == mmTmp) && (ss == ssTmp)) {
                        break;
                }
                if ((hhmmss == 2) && (ss == ssTmp)) {
                        break;
                }
                //b̕\ 
                disp_date_time();
                //
                if (SW_STOP == 0) {
                        return;
                }
        }
        //|[g̐sB 
        if (strstr(line_data, "ALL_ON") != 0x00) {
                CH1 = on_data;
                CH2 = on_data;
                CH3 = on_data;
                CH4 = on_data;
                CH5 = on_data;
                CH6 = on_data;
                CH7 = on_data;
                CH8 = on_data;
        }
        if (strstr(line_data, "ALL_OFF") != 0x00) {
                CH1 = off_data;
                CH2 = off_data;
                CH3 = off_data;
                CH4 = off_data;
                CH5 = off_data;
                CH6 = off_data;
                CH7 = off_data;
                CH8 = off_data;
        }
        if (strstr(line_data, "ALL_REV") != 0x00) {
                CH_PORT = ~CH_PORT;
        }
        tmp[0] = 'C';
        tmp[1] = 'H';
        tmp[2] = '?';
        tmp[3] = '=';
        tmp[4] = 0x00;
        for (channel = 1; channel <= 8; channel++) {
                tmp[2] = channel + '0';
                pnt = strstr(line_data, tmp);
                if (pnt != 0x00) {
                        if (strncmp((pnt + 4), "ON", 2) == 0) {
                                output_data = on_data;
                        } else {
                                output_data = off_data;
                        }
                        switch (channel) {
                        case 1:
                                CH1 = output_data;
                                break;
                        case 2:
                                CH2 = output_data;
                                break;
                        case 3:
                                CH3 = output_data;
                                break;
                        case 4:
                                CH4 = output_data;
                                break;
                        case 5:
                                CH5 = output_data;
                                break;
                        case 6:
                                CH6 = output_data;
                                break;
                        case 7:
                                CH7 = output_data;
                                break;
                        case 8:
                                CH8 = output_data;
                                break;
                        }
                }
        }
}
//********************************************************************** 
//^C}[s֐łB 
#define MODE_DEF       0
#define MODE_INIT      1
#define MODE_START     2
#define MODE_STOP      3
#define MODE_END       4
#define MODE_NON       5
//
void    timer_proc()
{
        //ϐ̒` 
        char    line_data[80], *pnt;
        short   line_length;
        BYTE    mode, on_data, off_data, hhmmss;
        WORD    line_cnt;
        //ϐ̏ 
        mode = MODE_NON;
        line_cnt = 0;
        on_data = 1;
        off_data = 0;
        hhmmss = 0;
        //llb̃t@C̃I[v 
        if (file_open(file_name) == -1) {
                Lcd_Out(2, 9, "error!");
                Delay_ms(500);
                return;
        }
        //
        Lcd_Out(2, 7, "line=");
        while (SW_STOP != 0) {
                //ݒt@C1s̃f[^ǂݍ 
                line_length = file_read_line(line_data);
                if (line_length == -1) {
                        return;
                }
                line_cnt++;
                WordToStr(line_cnt, buf);
                chrrep(buf, ' ', '0');
                Lcd_Out(2, 12, buf);
                //`𔻒fB 
                pnt = strstr(line_data, "$DEF");
                if (pnt != 0x00) {
                        mode = MODE_DEF;
                        continue;
                }
                //𔻒fB 
                pnt = strstr(line_data, "$INIT");
                if (pnt != 0x00) {
                        mode = MODE_INIT;
                        continue;
                }
                //Jn𔻒fB 
                pnt = strstr(line_data, "$START");
                if (pnt != 0x00) {
                        mode = MODE_START;
                        continue;
                }
                //~𔻒fB 
                pnt = strstr(line_data, "$STOP");
                if (pnt != 0x00) {
                        mode = MODE_STOP;
                        continue;
                }
                //I𔻒fB 
                pnt = strstr(line_data, "$END");
                if (pnt != 0x00) {
                        mode = MODE_END;
                        return;
                }
                //słΉȂB
                if (line_length == 0) {
                        continue;
                }
                //`̐ݒ 
                if (mode == MODE_DEF) {
                        timer_proc_def(line_data, &on_data, &off_data, &hhmmss);
                        continue;
                }
                //Ԃݒ肷B 
                if (mode == MODE_INIT) {
                        timer_proc_init(line_data, on_data, off_data);
                        continue;
                }
                //^C}[vOsB
                if (mode == MODE_START) {
                        timer_proc_start(line_data, on_data, off_data, hhmmss);
                        continue;
                }
                //~Ԃݒ肷 
                if (mode == MODE_STOP) {
                        timer_proc_init(line_data, on_data, off_data);
                        continue;
                }
        }
}
//********************************************************************** 
//샂[h擾֐łB 
short   get_mode()
{
        if ((SW_MODE_1 == 0) && (SW_MODE_0 == 0)) {
                return (0);
        }
        if ((SW_MODE_1 == 0) && (SW_MODE_0 == 1)) {
                return (1);
        }
        if ((SW_MODE_1 == 1) && (SW_MODE_0 == 0)) {
                return (2);
        }
        if ((SW_MODE_1 == 1) && (SW_MODE_0 == 1)) {
                return (3);
        }
}
//********************************************************************** 
//^C}[s֐łB 
void    run_mode0()
{
        Lcd_Out(2, 1, "                ");
        if (SW_START != 0) {
                return;
        }
        Lcd_Out(2, 1, "START           ");
        //
        timer_proc();
        //
        Lcd_Out(2, 1, "STOP            ");
        Delay_ms(500);
        Lcd_Cmd(_LCD_CLEAR);
}
//********************************************************************** 
//킹֐łB 
void    run_mode1()
{
        BYTE    td, td_hour, td_min;
        //
        Lcd_Out(2, 1, "clock adjust    ");
        //gh̐ݒ 
        if (SW_HOUR == 0) {
                while (SW_HOUR == 0) {
                        Delay_ms(100);
                }
                td_hour = RTC_8564_Read(4) & 0x3F;
                td = Bcd2Dec(td_hour);
                td++;
                if (td >= 24) {
                        td = 0;
                }
                td_hour = Dec2Bcd(td);
                RTC_8564_Write(4, td_hour);
        }
        //gh̐ݒ
        if (SW_MINUTE == 0) {
                while (SW_MINUTE == 0) {
                        Delay_ms(100);
                }
                td_min = RTC_8564_Read(3) & 0x7F;
                td = Bcd2Dec(td_min);
                td++;
                if (td >= 60) {
                        td = 0;
                }
                td_min = Dec2Bcd(td);
                RTC_8564_Write(3, td_min);
                RTC_8564_Write(2, 0);
        }
}
//********************************************************************** 
//t킹֐łB 
void    run_mode2()
{
        BYTE    td, td_month, td_day;
        //
        Lcd_Out(2, 1, "date adjust     ");
        //gh̐ݒ
        if (SW_MONTH == 0) {
                while (SW_MONTH == 0) {
                        Delay_ms(100);
                }
                td_month = RTC_8564_Read(7) & 0x1F;
                td = Bcd2Dec(td_month);
                td++;
                if (td >= 13) {
                        td = 1;
                }
                td_month = Dec2Bcd(td);
                RTC_8564_Write(7, td_month);
        }
        //gh̐ݒ
        if (SW_DAY == 0) {
                while (SW_DAY == 0) {
                        Delay_ms(100);
                }
                td_day = RTC_8564_Read(5) & 0x3F;
                td = Bcd2Dec(td_day);
                td++;
                if (td >= 32) {
                        td = 1;
                }
                td_day = Dec2Bcd(td);
                RTC_8564_Write(5, td_day);
        }
}
//********************************************************************** 
//t@CiP`XXXjύX֐łB 
void    run_mode3()
{
        Lcd_Out(2, 1, file_name);
        //
        if (SW_UP == 0) {
                while (SW_UP == 0) {
                        Delay_ms(100);
                }
                file_id++;
                if (file_id == 1000) {
                        file_id = 1;
                }
                //
                write_file_name();
        }
        if (SW_DOWN == 0) {
                while (SW_DOWN == 0) {
                        Delay_ms(100);
                }
                file_id--;
                if (file_id == 0) {
                        file_id = 999;
                }
                //
                write_file_name();
        }
}
//********************************************************************** 
//t@CEEPROMǂݍފ֐łB 
void    read_file_name()
{
        file_id = EEPROM_Read(0);
        file_id <<= 8;
        file_id |= EEPROM_Read(1);
        if ((file_id < 1) || (file_id > 999)) {
                file_id = 1;
        }
        //
        WordToStr(file_id, buf);
        chrrep(buf, ' ', '0');
        file_name[5] = buf[2];
        file_name[6] = buf[3];
        file_name[7] = buf[4];
}
//********************************************************************** 
//t@CEEPROMɏފ֐łB 
void    write_file_name()
{
        EEPROM_Write(0, (file_id >> 8) & 0xFF);
        EEPROM_Write(1, file_id & 0xFF);
        //
        WordToStr(file_id, buf);
        chrrep(buf, ' ', '0');
        file_name[5] = buf[2];
        file_name[6] = buf[3];
        file_name[7] = buf[4];
}
//********************************************************************** 
void    chrrep(char *str, char a, char b)
{
        while (*str != 0x00) {
                if (*str == a) {
                        *str = b;
                }
                str++;
        }
}
//********************************************************************** 
//kdc_Ŋ֐łB 
void    all_complete()
{
        short   cnt;
        //
        for (cnt = 0; cnt < 10; cnt++) {
                LED1 = 1;
                LED2 = 1;
                LED3 = 1;
                LED4 = 1;
                Delay_ms(100);
                LED1 = 0;
                LED2 = 0;
                LED3 = 0;
                LED4 = 0;
                Delay_ms(100);
        }
}
//********************************************************************** 